a = 0;
b = 1;
Kg = 1; 
Kd = 10;

solex =  @(x) (x<0.5).*((x-0.5).*(5.*(x-0.5).^4+4*(x-0.5).^3+3*(x-0.5).^2+2*(x-0.5)+Kd)) ...
      +(x>=0.5).*((x-0.5).*(Kg*sin(pi.*x)+5*cos(pi.*x) ))
rhsfun = @(x) (x<0.5).*(-2*Kg*(20.*(x-0.5).^3+12*(x-0.5).^2+6*(x-0.5)+2) ...
      -Kg*(x-0.5).*(60.*(x-0.5).^2+24*(x-0.5)+6)) ...
      +(x>=0.5).*(-2*Kd*(Kg*pi*cos(pi.*x)-5*pi*sin(pi.*x) ) ...
      +Kd*(x-0.5).*(Kg*pi*pi*sin(pi.*x)+5*pi*pi*cos(pi.*x) )  );

% solex = @(x) sin(pi*x);
% rhsfun = @(x) pi*pi*sin(pi*x);
                            
bcleftD.type = 'Dirichlet';
bcleftD.value = solex(0);  
bcrightD.type = 'Dirichlet';
bcrightD.value = solex(1);
bclist = [bcleftD, bcrightD];

n=20;
h = (b-a)/n;
x = linspace(a+0.5*h, b-0.5*h, n)';
K = ones(size(x));
K(1:n/2) = Kg;
K(n/2+1:n) = Kd;
moyenne = "harmonique";
uh = solve(a, b, n, K, rhsfun, bclist, moyenne);
moyenne = "arithmetique";
ua = solve(a, b, n, K, rhsfun, bclist, moyenne);
uex = solex(x);
erra = norm(ua-uex,2)*sqrt(h)
errh = norm(uh-uex,2)*sqrt(h)

subplot(211)
plot(x, uh, '-o', x, ua, '-+', x, uex, '--', 'LineWidth',2 );
legend('moy. harm.', 'moy. arith.', 'sol. exacte');
xlabel('x ');
ylabel('u(x)');
subplot(212)
plot(x, abs(uh-uex), x, abs(ua-uex), 'LineWidth',2 );
legend('moy. harm.', 'moy. arith.');
xlabel('x ');
ylabel('Erreur');


nlist = 20:20:200;
errsa =[]; errsh=[];
for n = nlist
    h = (b-a)/n;
    x = linspace(a+0.5*h, b-0.5*h, n)';
    K = ones(size(x));
    K(1:n/2) = Kg;
    K(n/2+1:n) = Kd;
    moyenne = "harmonique";
    uh = solve(a, b, n, K, rhsfun, bclist, moyenne);
    moyenne = "arithmetique";
    ua = solve(a, b, n, K, rhsfun, bclist, moyenne);
    uex = solex(x);
    errsa = [errsa, norm(ua-uex,2)*sqrt(h)];
    errsh = [errsh, norm(uh-uex,2)*sqrt(h)];
end

figure(2)
loglog(1 ./ nlist, errsa, '-+', 1 ./ nlist, errsh, '- o', 1 ./ nlist, nlist.^(-1), '--', 1 ./ nlist, nlist.^(-2),  '--', 'LineWidth',2)
xlabel('h'); ylabel('erreur');
legend('moy. arith', 'moy. harm.', 'pente 1', 'pente 2');

