a = 0;
b = 1;
n = 20;
h = (b-a)/n;
x = linspace(a+0.5*h, b-0.5*h, n)';
K = 3;
bcs=[1., 2.];
rhsfun = @(x) 6 * ones(size(x));

u = solve(a, b, n, K, rhsfun, bcs);
solex = @(x)  x .* (1 - x) + x + 1;
uex = solex(x);
erreur = norm(u-uex,2)*sqrt(h);
fprintf("erreur= %g \n", erreur);

subplot(211)
plot(x, u, x, uex,'LineWidth',2 );
legend('sol. approchée', 'sol. exacte');
xlabel('x ');
ylabel('u(x)');
subplot(212)
plot(x, abs(u-uex), 'LineWidth',2 );
xlabel('x ');
ylabel('Erreur');


nliste = [10 20 40 80 160 320];
errs=[];
for n = nliste
    h = (b-a)/n;
    x = linspace(a+0.5*h, b-0.5*h, n)';
    u = solve(a, b, n, K, rhsfun, bcs);
    uex = solex(x);
    errs = [errs, norm(u-uex,2)*sqrt(h)];
end
figure(2)
loglog(nliste, errs, '-+', nliste, nliste.^(-2), '--')
