a = 0;
b = 1;
n = 20;
h = (b-a)/n;
x = linspace(a+0.5*h, b-0.5*h, n)';
t0 = 0;
tf = .1;
dt = 0.001;
theta = 0.;
K = 1;
uinit = sin(pi*x/2) + 0.5 * sin(2*pi*x);

bcs = @(t) [0., exp(-pi^2*t/4)];
rhsfunc = @(x) zeros(size(x));

figure()

[ts, u] = time_loop(a, b, n, K, rhsfunc, bcs, t0, tf, dt, theta, uinit);

solex = @(x, t) exp(-pi^2*t/4) * sin(pi*x/2.) + 0.5 * exp(-4*pi^2*t) * sin(2*pi*x);

fprintf("Fourier= %g\n", K*dt/h^2);
errxt=0;
for i = 1:size(u,1)
    errxt = errxt + norm(u(:,i) - solex(x,ts(i)),2)^2*h;
end
errxt = sqrt(errxt*dt);
errfin = norm(u(:, end) - solex(x,ts(end)),2)*sqrt(h);
fprintf("erreur x-t= %g, finale= %g \n", errxt, errfin);

for i = 1:size(u,2)
    plot(x,u(:,i),x,solex(x, ts(i)), 'LineWidth',2);
    xlabel('x');
    ylabel('u');
    legend('sol. approchée', 'sol. exacte');
    axis([a, b, 0., 1.])
    pause(0.1);
end